(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 4)) 10))
(assert (= (f1 (g1 9)) 57))
(assert (= (f1 (f2 2)) 7))
(assert (= (f1 (g2 4)) 19))
(assert (= (f1 (f3 3)) 10))
(assert (= (f1 (g3 2)) 19))
(assert (= (g1 (f3 9)) 78))
(assert (= (f1 (g4 3)) 57))
(assert (= (g1 (f4 4)) 78))
(assert (= (f2 (f1 2)) 7))
(assert (= (f2 (g1 4)) 26))
(assert (= (f2 (f2 3)) 7))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 9)) 44))
(assert (= (f2 (g3 3)) 26))
(assert (= (g2 (f3 4)) 32))
(assert (= (g2 (f4 2)) 44))
(assert (= (f2 (f4 9)) 20))
(assert (= (g2 (g4 9)) 648))
(assert (= (f3 (f1 3)) 10))
(assert (= (f3 (g1 2)) 16))
(assert (= (g3 (f1 9)) 96))
(assert (= (f3 (g2 3)) 16))
(assert (= (g3 (f2 4)) 48))
(assert (= (g3 (f3 2)) 48))
(assert (= (f3 (f3 9)) 17))
(assert (= (g3 (g3 9)) 576))
(assert (= (g3 (f4 3)) 96))
(assert (= (f3 (f4 4)) 17))
(assert (= (g3 (g4 4)) 576))
(assert (= (f4 (g1 3)) 27))
(assert (= (g4 (f1 4)) 126))
(assert (= (g4 (f2 2)) 72))
(assert (= (f4 (f2 9)) 20))
(assert (= (g4 (g2 9)) 648))
(assert (= (g4 (f3 3)) 126))
(assert (= (f4 (f3 4)) 17))
(assert (= (g4 (g3 4)) 576))
(assert (= (f4 (f4 2)) 20))
(assert (= (g4 (g4 2)) 648))
(check-sat)
